import IKDBBaseQuery from './IKDBBaseQuery';
import Utils from './../API/IKUtils';
//
import AWS from "aws-sdk";
//
export default class IKDBQueryUpdate extends IKDBBaseQuery {
  constructor(indexName) {
    super(indexName)
  }
  //
  async run(dbManager) {
    const resp = await this.rawRun(dbManager);
    const unmarshalled = Utils.decapsulateForDB(resp.Items);
    console.log('Parsed result: ', unmarshalled);
    return unmarshalled;
  }
  async rawRun(dbManager) {
    let query = this._rawQuery(dbManager.tableName);
    console.log("Deleting item: ", query);
    let resp = await dbManager.connection.deleteItem(query).promise();
    console.debug('Raw result: ', resp);
    return resp;
  }

  _rawQuery(dbTableName, isTransaction) {
    return { ...super._rawQuery(dbTableName, isTransaction),
             ...(isTransaction ? {} : {ReturnValues: "ALL_OLD" /*request all deleted values*/ })};
  }
}
