import IKDBBaseQuery from './IKDBBaseQuery';
import Utils from './../API/IKUtils';
//
import AWS from "aws-sdk";
//
export default class IKDBQueryGet extends IKDBBaseQuery {
  constructor(optIndexName) {
    super(optIndexName);
  }
  async run(dbManager, appendingItems) {
    const resp = await this.rawRun(dbManager);
    if (resp.Items) {
      let unmarshalled = Utils.decapsulateForDB(resp.Items);
      console.debug('Parsed result: ', unmarshalled);
      //Check for appending items from previous query
      if (appendingItems && appendingItems.length > 0) {
        unmarshalled = unmarshalled.concat(appendingItems);
      }
      //Check for continuation
      if (resp.LastEvaluatedKey) {
        this.ExclusiveStartKey = resp.LastEvaluatedKey;
        return this.run(dbManager, unmarshalled);
      } return unmarshalled;
    } return null;
  }
  async rawRun(dbManager) {
    const query = this._rawQuery(dbManager.tableName);
    console.log('Querying: ', query);
    const resp = await dbManager.connection.query(query).promise();
    console.debug('Raw result: ', resp);
    return resp;
  }
}
