//Components
import Utils  from "./API/IKUtils";
import IKDB from "./Database/IKDB";
import IKLogger from "./Logger/IKLogger";
import IKGlobals from './IKGlobals';
import IKValidation from './Validation/IKValidation';
//
export default class IKProcess {
  constructor(config, interval) {
    this.interval = interval;
    this.logger = new IKLogger({/*COFIG S3/SQS HERE*/}, Utils.logLevel());
    this.db = new IKDB(config.database);
    this.validator = new IKValidation(config.validation);
  }

  //Main interface
  async execute(executionFunc) {
    console.debug("Starting main process code");
    //program loop
    setInterval( async () => {
      await this._execute(executionFunc);
    }, this.interval);
  }
  //Executions
  async _execute(executionFunc) {
    let executionFailed = true; //failled til we say no!
    //safe execution handler
    try { //Execute
      await executionFunc(this);
      executionFailed = false;
    } catch (e) { /*EXECUTION FAIL*/
      console.error('Exception when executing main request code.');
      console.exception(e);
    } return executionFailed;
  }
}
